.686
.mmx
.xmm
.model flat, stdcall
	option casemap:none
	include \masm32\include\windows.inc
	
	include \masm32\include\masm32.inc
	includelib \masm32\lib\masm32.lib

	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib
	
	include	\masm32\macros\timers.asm
	include \masm32\macros\macros.asm

.const
	loop_count	equ		2000000000 ;2,000,000,000

.data
	bitmsk      db  128,64,32,16,8,4,2,1
	ascmsk      db  8 dup (31h)
	str2		db 33 dup (0)

.code

QwordMmx proc ;original version by qWord
	bswap edx
    movq mm6,QWORD ptr [bitmsk]
    movq mm7,QWORD ptr [ascmsk]
    pxor mm5,mm5

    movd mm0,edx
    punpcklbw mm0,mm0

    movq mm1,mm0
    pshufw mm1,mm0,0
    pand mm1,mm6
    pcmpeqb mm1,mm5
    paddsb mm1,mm7
    movq QWORD ptr [ecx],mm1

    movq mm2,mm0
    pshufw mm2,mm0,001010101y
    pand mm2,mm6
    pcmpeqb mm2,mm5
    paddsb mm2,mm7
    movq QWORD ptr [ecx+8],mm2

    movq mm1,mm0
    pshufw mm1,mm0,010101010y
    pand mm1,mm6
    pcmpeqb mm1,mm5
    paddsb mm1,mm7
    movq QWORD ptr [ecx+16],mm1

    movq mm2,mm0
    pshufw mm2,mm0,011111111y
    pand mm2,mm6
    pcmpeqb mm2,mm5
    paddsb mm2,mm7
    movq QWORD ptr [ecx+24],mm2

    mov BYTE ptr [ecx+32],0

    ret

QwordMmx endp

_QwordMmx proc ;modified version by Drizz
 	movq mm6,QWORD ptr [bitmsk]
	movq mm7,QWORD ptr [ascmsk]
	pxor mm5,mm5
	movd mm0,eax
	
	punpcklbw mm0,mm0
	punpcklwd mm1,mm0
	movq mm2,mm0
	punpckhwd mm3,mm0
	
	punpcklwd mm0,mm0
	punpckhwd mm1,mm1
	punpckhwd mm2,mm2
	punpckhwd mm3,mm3
	
	punpckldq mm0,mm0
	punpckhdq mm1,mm1
	punpckldq mm2,mm2
	punpckhdq mm3,mm3
	
	pand mm0,mm6
	pand mm1,mm6
	pand mm2,mm6
	pand mm3,mm6
	
	pcmpeqb mm0,mm5
	pcmpeqb mm1,mm5
	pcmpeqb mm2,mm5
	pcmpeqb mm3,mm5
	
	paddb mm0,mm7
	paddb mm1,mm7
	paddb mm2,mm7
	paddb mm3,mm7
	
	movq [edx+24],mm0
	movq [edx+16],mm1
	movq [edx+8],mm2
	movq [edx],mm3
	mov BYTE ptr [edx+32],0
    ret
_QwordMmx endp

__QwordMmx proc ;another modification :)
	movq mm7, QWORD ptr [ascmsk]
	movq mm6, QWORD ptr [bitmsk]
	pxor mm5, mm5
	movd mm0, eax
	
	punpcklbw mm0, mm0
	punpckhdq mm2, mm0
	
	punpcklwd mm0, mm0
	punpckhwd mm2, mm2

	punpckhdq mm1, mm0
	punpckhdq mm3, mm2
	
	punpckldq mm0, mm0
	punpckhdq mm1, mm1
	punpckldq mm2, mm2
	punpckhdq mm3, mm3

	pand mm0, mm6
	pand mm1, mm6
	pand mm2, mm6
	pand mm3, mm6
	
	pcmpeqb mm0, mm5
	pcmpeqb mm1, mm5
	pcmpeqb mm2, mm5
	pcmpeqb mm3, mm5
	
	paddb mm0,mm7
	paddb mm1,mm7
	paddb mm2,mm7
	paddb mm3,mm7
	
	movq [edx+24],mm0
	movq [edx+16],mm1
	movq [edx+08],mm2
	movq [edx+00],mm3
	mov BYTE ptr [edx+32],0
	retn
__QwordMmx endp

start:
	push	ebp
	mov		ebp,esp
		print "Loop count: "
		print str$(loop_count),10,13
		
		print "Method: timer_begin\timer_end:",10,13
		timer_begin loop_count,HIGH_PRIORITY_CLASS
			mov		edx, 00010010001101000101011001111000b
			mov		ecx, offset str2
			call 	QwordMmx
		timer_end
		print str$(eax), " {"
		print (offset str2),"} QwordMmx(1) - qWord",10,13
		timer_begin loop_count,HIGH_PRIORITY_CLASS
			mov		edx, 00010010001101000101011001111000b
			mov		ecx, offset str2
			call 	QwordMmx
		timer_end
		print str$(eax), " {"
		print (offset str2),"} QwordMmx(2) - qWord",10,13
		
		timer_begin loop_count,HIGH_PRIORITY_CLASS
			mov		eax, 00010010001101000101011001111000b
			mov		edx, offset str2
			call 	_QwordMmx
		timer_end
		print str$(eax), " {"
		print (offset str2),"} _QwordMmx(1) - drizz",10,13
		timer_begin loop_count,HIGH_PRIORITY_CLASS
			mov		eax, 00010010001101000101011001111000b
			mov		edx, offset str2
			call 	_QwordMmx
		timer_end
		print str$(eax), " {"
		print (offset str2),"} _QwordMmx(2) - drizz",10,13
		
		timer_begin loop_count,HIGH_PRIORITY_CLASS
			mov		eax, 00010010001101000101011001111000b
			mov		edx, offset str2
			call 	__QwordMmx
		timer_end
		print str$(eax), " {"
		print (offset str2),"} __QwordMmx(1) - DoomyD",10,13
		timer_begin loop_count,HIGH_PRIORITY_CLASS
			mov		eax, 00010010001101000101011001111000b
			mov		edx, offset str2
			call 	__QwordMmx
		timer_end
		print str$(eax), " {"
		print (offset str2),"} __QwordMmx(2) - DoomyD",10,13
	
		
		
		invoke	Sleep,7000
		xor		eax,eax
	pop		ebp
	retn
end start